diff --git a/modules/DiWheelDrive_1-2/aosconf.h b/modules/DiWheelDrive_1-2/aosconf.h
index 8bb97df..73246cc 100644
--- a/modules/DiWheelDrive_1-2/aosconf.h
+++ b/modules/DiWheelDrive_1-2/aosconf.h
@@ -280,7 +280,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   Shell maximum input line length.
  */
 #if !defined(OS_CFG_SHELL_LINEWIDTH)
-  #define AMIROOS_CFG_SHELL_LINEWIDTH           80
+  #define AMIROOS_CFG_SHELL_LINEWIDTH           64
 #else /* !defined(OS_CFG_SHELL_LINEWIDTH) */
   #define AMIROOS_CFG_SHELL_LINEWIDTH           OS_CFG_SHELL_LINEWIDTH
 #endif /* !defined(OS_CFG_SHELL_LINEWIDTH) */
@@ -294,6 +294,16 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
   #define AMIROOS_CFG_SHELL_MAXARGS             OS_CFG_SHELL_MAXARGS
 #endif /* !defined(OS_CFG_SHELL_MAXARGS) */
 
+/**
+ * @brief   Shell number of history entries.
+ * @details A value of 0 disables shell history.
+ */
+#if !defined(OS_CFG_SHELL_HISTLENGTH)
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          3
+#else /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          OS_CFG_SHELL_HISTLENGTH
+#endif /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+
 /** @} */
 
 #endif /* AOSCONF_H */
diff --git a/modules/LightRing_1-0/Makefile b/modules/LightRing_1-0/Makefile
index 6557859..3cb02ec 100644
--- a/modules/LightRing_1-0/Makefile
+++ b/modules/LightRing_1-0/Makefile
@@ -35,7 +35,7 @@ endif
 
 # C specific options here (added to USE_OPT).
 ifeq ($(USE_COPT),)
-  USE_COPT = -std=c17
+  USE_COPT = -std=c99 -fshort-enums
 endif
 
 # C++ specific options here (added to USE_OPT).
diff --git a/modules/LightRing_1-0/aosconf.h b/modules/LightRing_1-0/aosconf.h
index 747bb25..973e80a 100644
--- a/modules/LightRing_1-0/aosconf.h
+++ b/modules/LightRing_1-0/aosconf.h
@@ -280,7 +280,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   Shell maximum input line length.
  */
 #if !defined(OS_CFG_SHELL_LINEWIDTH)
-  #define AMIROOS_CFG_SHELL_LINEWIDTH           80
+  #define AMIROOS_CFG_SHELL_LINEWIDTH           64
 #else /* !defined(OS_CFG_SHELL_LINEWIDTH) */
   #define AMIROOS_CFG_SHELL_LINEWIDTH           OS_CFG_SHELL_LINEWIDTH
 #endif /* !defined(OS_CFG_SHELL_LINEWIDTH) */
@@ -294,6 +294,16 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
   #define AMIROOS_CFG_SHELL_MAXARGS             OS_CFG_SHELL_MAXARGS
 #endif /* !defined(OS_CFG_SHELL_MAXARGS) */
 
+/**
+ * @brief   Shell number of history entries.
+ * @details A value of 0 disables shell history.
+ */
+#if !defined(OS_CFG_SHELL_HISTLENGTH)
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          3
+#else /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          OS_CFG_SHELL_HISTLENGTH
+#endif /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+
 /** @} */
 
 #endif /* AOSCONF_H */
diff --git a/modules/LightRing_1-2/Makefile b/modules/LightRing_1-2/Makefile
index 0d20422..8a901ad 100644
--- a/modules/LightRing_1-2/Makefile
+++ b/modules/LightRing_1-2/Makefile
@@ -35,7 +35,7 @@ endif
 
 # C specific options here (added to USE_OPT).
 ifeq ($(USE_COPT),)
-  USE_COPT = -std=c17
+  USE_COPT = -std=c99 -fshort-enums
 endif
 
 # C++ specific options here (added to USE_OPT).
diff --git a/modules/LightRing_1-2/aosconf.h b/modules/LightRing_1-2/aosconf.h
index 66eddd5..885581e 100644
--- a/modules/LightRing_1-2/aosconf.h
+++ b/modules/LightRing_1-2/aosconf.h
@@ -280,7 +280,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   Shell maximum input line length.
  */
 #if !defined(OS_CFG_SHELL_LINEWIDTH)
-  #define AMIROOS_CFG_SHELL_LINEWIDTH           80
+  #define AMIROOS_CFG_SHELL_LINEWIDTH           64
 #else /* !defined(OS_CFG_SHELL_LINEWIDTH) */
   #define AMIROOS_CFG_SHELL_LINEWIDTH           OS_CFG_SHELL_LINEWIDTH
 #endif /* !defined(OS_CFG_SHELL_LINEWIDTH) */
@@ -294,6 +294,16 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
   #define AMIROOS_CFG_SHELL_MAXARGS             OS_CFG_SHELL_MAXARGS
 #endif /* !defined(OS_CFG_SHELL_MAXARGS) */
 
+/**
+ * @brief   Shell number of history entries.
+ * @details A value of 0 disables shell history.
+ */
+#if !defined(OS_CFG_SHELL_HISTLENGTH)
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          3
+#else /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          OS_CFG_SHELL_HISTLENGTH
+#endif /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+
 /** @} */
 
 #endif /* AOSCONF_H */
diff --git a/modules/NUCLEO-F103RB/Makefile b/modules/NUCLEO-F103RB/Makefile
index 121c5b1..6c37e02 100644
--- a/modules/NUCLEO-F103RB/Makefile
+++ b/modules/NUCLEO-F103RB/Makefile
@@ -35,7 +35,7 @@ endif
 
 # C specific options here (added to USE_OPT).
 ifeq ($(USE_COPT),)
-  USE_COPT = -std=c17
+  USE_COPT = -std=c99 -fshort-enums
 endif
 
 # C++ specific options here (added to USE_OPT).
diff --git a/modules/NUCLEO-F103RB/aosconf.h b/modules/NUCLEO-F103RB/aosconf.h
index 605f402..34b0122 100644
--- a/modules/NUCLEO-F103RB/aosconf.h
+++ b/modules/NUCLEO-F103RB/aosconf.h
@@ -280,7 +280,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   Shell maximum input line length.
  */
 #if !defined(OS_CFG_SHELL_LINEWIDTH)
-  #define AMIROOS_CFG_SHELL_LINEWIDTH           80
+  #define AMIROOS_CFG_SHELL_LINEWIDTH           64
 #else /* !defined(OS_CFG_SHELL_LINEWIDTH) */
   #define AMIROOS_CFG_SHELL_LINEWIDTH           OS_CFG_SHELL_LINEWIDTH
 #endif /* !defined(OS_CFG_SHELL_LINEWIDTH) */
@@ -294,6 +294,16 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
   #define AMIROOS_CFG_SHELL_MAXARGS             OS_CFG_SHELL_MAXARGS
 #endif /* !defined(OS_CFG_SHELL_MAXARGS) */
 
+/**
+ * @brief   Shell number of history entries.
+ * @details A value of 0 disables shell history.
+ */
+#if !defined(OS_CFG_SHELL_HISTLENGTH)
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          3
+#else /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          OS_CFG_SHELL_HISTLENGTH
+#endif /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+
 /** @} */
 
 #endif /* AOSCONF_H */
diff --git a/modules/NUCLEO-F401RE/Makefile b/modules/NUCLEO-F401RE/Makefile
index a21eb75..8eedcb9 100644
--- a/modules/NUCLEO-F401RE/Makefile
+++ b/modules/NUCLEO-F401RE/Makefile
@@ -35,7 +35,7 @@ endif
 
 # C specific options here (added to USE_OPT).
 ifeq ($(USE_COPT),)
-  USE_COPT = -std=c17
+  USE_COPT = -std=c99 -fshort-enums
 endif
 
 # C++ specific options here (added to USE_OPT).
diff --git a/modules/NUCLEO-F401RE/aosconf.h b/modules/NUCLEO-F401RE/aosconf.h
index b0729a7..7c69db1 100644
--- a/modules/NUCLEO-F401RE/aosconf.h
+++ b/modules/NUCLEO-F401RE/aosconf.h
@@ -280,7 +280,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   Shell maximum input line length.
  */
 #if !defined(OS_CFG_SHELL_LINEWIDTH)
-  #define AMIROOS_CFG_SHELL_LINEWIDTH           80
+  #define AMIROOS_CFG_SHELL_LINEWIDTH           64
 #else /* !defined(OS_CFG_SHELL_LINEWIDTH) */
   #define AMIROOS_CFG_SHELL_LINEWIDTH           OS_CFG_SHELL_LINEWIDTH
 #endif /* !defined(OS_CFG_SHELL_LINEWIDTH) */
@@ -294,6 +294,16 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
   #define AMIROOS_CFG_SHELL_MAXARGS             OS_CFG_SHELL_MAXARGS
 #endif /* !defined(OS_CFG_SHELL_MAXARGS) */
 
+/**
+ * @brief   Shell number of history entries.
+ * @details A value of 0 disables shell history.
+ */
+#if !defined(OS_CFG_SHELL_HISTLENGTH)
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          3
+#else /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          OS_CFG_SHELL_HISTLENGTH
+#endif /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+
 /** @} */
 
 #endif /* AOSCONF_H */
diff --git a/modules/NUCLEO-F767ZI/Makefile b/modules/NUCLEO-F767ZI/Makefile
index c00cef9..269dac4 100644
--- a/modules/NUCLEO-F767ZI/Makefile
+++ b/modules/NUCLEO-F767ZI/Makefile
@@ -35,7 +35,7 @@ endif
 
 # C specific options here (added to USE_OPT).
 ifeq ($(USE_COPT),)
-  USE_COPT = -std=c17
+  USE_COPT = -std=c99 -fshort-enums
 endif
 
 # C++ specific options here (added to USE_OPT).
diff --git a/modules/NUCLEO-F767ZI/aosconf.h b/modules/NUCLEO-F767ZI/aosconf.h
index dec9743..80cae03 100644
--- a/modules/NUCLEO-F767ZI/aosconf.h
+++ b/modules/NUCLEO-F767ZI/aosconf.h
@@ -280,7 +280,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   Shell maximum input line length.
  */
 #if !defined(OS_CFG_SHELL_LINEWIDTH)
-  #define AMIROOS_CFG_SHELL_LINEWIDTH           128
+  #define AMIROOS_CFG_SHELL_LINEWIDTH           64
 #else /* !defined(OS_CFG_SHELL_LINEWIDTH) */
   #define AMIROOS_CFG_SHELL_LINEWIDTH           OS_CFG_SHELL_LINEWIDTH
 #endif /* !defined(OS_CFG_SHELL_LINEWIDTH) */
@@ -289,11 +289,21 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   Shell maximum number of arguments.
  */
 #if !defined(OS_CFG_SHELL_MAXARGS)
-  #define AMIROOS_CFG_SHELL_MAXARGS             16
+  #define AMIROOS_CFG_SHELL_MAXARGS             8
 #else /* !defined(OS_CFG_SHELL_MAXARGS) */
   #define AMIROOS_CFG_SHELL_MAXARGS             OS_CFG_SHELL_MAXARGS
 #endif /* !defined(OS_CFG_SHELL_MAXARGS) */
 
+/**
+ * @brief   Shell number of history entries.
+ * @details A value of 0 disables shell history.
+ */
+#if !defined(OS_CFG_SHELL_HISTLENGTH)
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          3
+#else /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          OS_CFG_SHELL_HISTLENGTH
+#endif /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+
 /** @} */
 
 #endif /* AOSCONF_H */
diff --git a/modules/NUCLEO-L476RG/Makefile b/modules/NUCLEO-L476RG/Makefile
index 5e547e6..d850e2e 100644
--- a/modules/NUCLEO-L476RG/Makefile
+++ b/modules/NUCLEO-L476RG/Makefile
@@ -35,7 +35,7 @@ endif
 
 # C specific options here (added to USE_OPT).
 ifeq ($(USE_COPT),)
-  USE_COPT = -std=c17
+  USE_COPT = -std=c99 -fshort-enums
 endif
 
 # C++ specific options here (added to USE_OPT).
diff --git a/modules/NUCLEO-L476RG/aosconf.h b/modules/NUCLEO-L476RG/aosconf.h
index 47031f4..16664e4 100644
--- a/modules/NUCLEO-L476RG/aosconf.h
+++ b/modules/NUCLEO-L476RG/aosconf.h
@@ -280,7 +280,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   Shell maximum input line length.
  */
 #if !defined(OS_CFG_SHELL_LINEWIDTH)
-  #define AMIROOS_CFG_SHELL_LINEWIDTH           80
+  #define AMIROOS_CFG_SHELL_LINEWIDTH           64
 #else /* !defined(OS_CFG_SHELL_LINEWIDTH) */
   #define AMIROOS_CFG_SHELL_LINEWIDTH           OS_CFG_SHELL_LINEWIDTH
 #endif /* !defined(OS_CFG_SHELL_LINEWIDTH) */
@@ -294,6 +294,16 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
   #define AMIROOS_CFG_SHELL_MAXARGS             OS_CFG_SHELL_MAXARGS
 #endif /* !defined(OS_CFG_SHELL_MAXARGS) */
 
+/**
+ * @brief   Shell number of history entries.
+ * @details A value of 0 disables shell history.
+ */
+#if !defined(OS_CFG_SHELL_HISTLENGTH)
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          3
+#else /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          OS_CFG_SHELL_HISTLENGTH
+#endif /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+
 /** @} */
 
 #endif /* AOSCONF_H */
diff --git a/modules/PowerManagement_1-1/Makefile b/modules/PowerManagement_1-1/Makefile
index c02d07c..81986bf 100644
--- a/modules/PowerManagement_1-1/Makefile
+++ b/modules/PowerManagement_1-1/Makefile
@@ -35,7 +35,7 @@ endif
 
 # C specific options here (added to USE_OPT).
 ifeq ($(USE_COPT),)
-  USE_COPT = -std=c17
+  USE_COPT = -std=c99 -fshort-enums
 endif
 
 # C++ specific options here (added to USE_OPT).
diff --git a/modules/PowerManagement_1-1/aosconf.h b/modules/PowerManagement_1-1/aosconf.h
index 9e53959..68b1234 100644
--- a/modules/PowerManagement_1-1/aosconf.h
+++ b/modules/PowerManagement_1-1/aosconf.h
@@ -280,7 +280,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   Shell maximum input line length.
  */
 #if !defined(OS_CFG_SHELL_LINEWIDTH)
-  #define AMIROOS_CFG_SHELL_LINEWIDTH           80
+  #define AMIROOS_CFG_SHELL_LINEWIDTH           64
 #else /* !defined(OS_CFG_SHELL_LINEWIDTH) */
   #define AMIROOS_CFG_SHELL_LINEWIDTH           OS_CFG_SHELL_LINEWIDTH
 #endif /* !defined(OS_CFG_SHELL_LINEWIDTH) */
@@ -294,6 +294,16 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
   #define AMIROOS_CFG_SHELL_MAXARGS             OS_CFG_SHELL_MAXARGS
 #endif /* !defined(OS_CFG_SHELL_MAXARGS) */
 
+/**
+ * @brief   Shell number of history entries.
+ * @details A value of 0 disables shell history.
+ */
+#if !defined(OS_CFG_SHELL_HISTLENGTH)
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          3
+#else /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          OS_CFG_SHELL_HISTLENGTH
+#endif /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+
 /** @} */
 
 #endif /* AOSCONF_H */
diff --git a/modules/PowerManagement_1-2/Makefile b/modules/PowerManagement_1-2/Makefile
index d526a51..02f355d 100644
--- a/modules/PowerManagement_1-2/Makefile
+++ b/modules/PowerManagement_1-2/Makefile
@@ -35,7 +35,7 @@ endif
 
 # C specific options here (added to USE_OPT).
 ifeq ($(USE_COPT),)
-  USE_COPT = -std=c17
+  USE_COPT = -std=c99 -fshort-enums
 endif
 
 # C++ specific options here (added to USE_OPT).
diff --git a/modules/PowerManagement_1-2/aosconf.h b/modules/PowerManagement_1-2/aosconf.h
index 0b1fa46..7de2ac8 100644
--- a/modules/PowerManagement_1-2/aosconf.h
+++ b/modules/PowerManagement_1-2/aosconf.h
@@ -280,7 +280,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   Shell maximum input line length.
  */
 #if !defined(OS_CFG_SHELL_LINEWIDTH)
-  #define AMIROOS_CFG_SHELL_LINEWIDTH           80
+  #define AMIROOS_CFG_SHELL_LINEWIDTH           64
 #else /* !defined(OS_CFG_SHELL_LINEWIDTH) */
   #define AMIROOS_CFG_SHELL_LINEWIDTH           OS_CFG_SHELL_LINEWIDTH
 #endif /* !defined(OS_CFG_SHELL_LINEWIDTH) */
@@ -294,6 +294,16 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
   #define AMIROOS_CFG_SHELL_MAXARGS             OS_CFG_SHELL_MAXARGS
 #endif /* !defined(OS_CFG_SHELL_MAXARGS) */
 
+/**
+ * @brief   Shell number of history entries.
+ * @details A value of 0 disables shell history.
+ */
+#if !defined(OS_CFG_SHELL_HISTLENGTH)
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          3
+#else /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          OS_CFG_SHELL_HISTLENGTH
+#endif /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+
 /** @} */
 
 #endif /* AOSCONF_H */
diff --git a/modules/STM32F407G-DISC1/Makefile b/modules/STM32F407G-DISC1/Makefile
index 93d5659..d341c74 100644
--- a/modules/STM32F407G-DISC1/Makefile
+++ b/modules/STM32F407G-DISC1/Makefile
@@ -35,7 +35,7 @@ endif
 
 # C specific options here (added to USE_OPT).
 ifeq ($(USE_COPT),)
-  USE_COPT = -std=c17
+  USE_COPT = -std=c99 -fshort-enums
 endif
 
 # C++ specific options here (added to USE_OPT).
diff --git a/modules/STM32F407G-DISC1/aosconf.h b/modules/STM32F407G-DISC1/aosconf.h
index a7258c7..0a6f799 100644
--- a/modules/STM32F407G-DISC1/aosconf.h
+++ b/modules/STM32F407G-DISC1/aosconf.h
@@ -280,7 +280,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   Shell maximum input line length.
  */
 #if !defined(OS_CFG_SHELL_LINEWIDTH)
-  #define AMIROOS_CFG_SHELL_LINEWIDTH           80
+  #define AMIROOS_CFG_SHELL_LINEWIDTH           64
 #else /* !defined(OS_CFG_SHELL_LINEWIDTH) */
   #define AMIROOS_CFG_SHELL_LINEWIDTH           OS_CFG_SHELL_LINEWIDTH
 #endif /* !defined(OS_CFG_SHELL_LINEWIDTH) */
@@ -294,6 +294,16 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
   #define AMIROOS_CFG_SHELL_MAXARGS             OS_CFG_SHELL_MAXARGS
 #endif /* !defined(OS_CFG_SHELL_MAXARGS) */
 
+/**
+ * @brief   Shell number of history entries.
+ * @details A value of 0 disables shell history.
+ */
+#if !defined(OS_CFG_SHELL_HISTLENGTH)
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          3
+#else /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          OS_CFG_SHELL_HISTLENGTH
+#endif /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+
 /** @} */
 
 #endif /* AOSCONF_H */
